#pragma once

#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>

#include "../../digraph.cpp"
#include "../zdd/convertEdgePermutation.cpp"

int pathWidth(DiGraph &G, std::vector<int> &perm) {
    int n = G.numVertices();
    int m = G.numEdges();
    std::vector<int> permInv(n);
    for(int i = 0; i < n; i++) permInv[perm[i]] = i;

    std::vector<std::pair<int, int>> edgePermutation = convertEdgePermutation_directed(G, perm);
    std::vector<int> beginInd(n, -1);
    std::vector<int> endInd(n, 0);
    for(int i = 0; i < m; i++) {
        int u = edgePermutation[i].first;
        int v = edgePermutation[i].second;
        if(beginInd[u] == -1) beginInd[u] = i;
        if(beginInd[v] == -1) beginInd[v] = i;
        endInd[u] = i;
        endInd[v] = i;
    }

    std::vector<std::vector<int>> frontier(m);
    for(int i = 0; i < n; i++) {
        for(int j = beginInd[i]; j <= endInd[i]; j++) {
            frontier[j].push_back(i);
        }
    }

    int maxMateSize = 0;
    for(int i = 0; i < m; i++) {
        if(maxMateSize < frontier[i].size()) {
            maxMateSize = frontier[i].size();
        }
    }

    std::vector<std::vector<int>> enterVertex(m);
    std::vector<std::vector<int>> leaveVertex(m);
    for(int i = 0; i < n; i++) {
        enterVertex[beginInd[i]].push_back(i);
        leaveVertex[endInd[i]].push_back(i);
    }
    
    return maxMateSize + 1;
}
