#include "graph.cpp"
#include "digraph.cpp"

Graph pathBfs(Graph G, int S) { // in G, out res(辺を隣接順にしただけ) 
    std::vector<std::pair<std::pair<int, int>,int>> res_edges;
    std::vector<std::vector<std::pair<int, int>>> res_inedge(G.numVertices()); //neighbor list
    std::vector<std::vector<std::pair<int, int>>> res_outedge(G.numVertices());
    std::vector<int> perm(G.numVertices());
    int idx=0;
    
    std::vector<std::vector<std::pair<int,int>>> neighbor(G.numVertices());
    for (int i = 0; i < G.numVertices(); i++) {
        neighbor[i] = G.getNeighbors(i);
    }
    // auto neighbor = G.getGraph(); // edge list

    // queueから出てくる頂点の隣接辺をリストに入れる
    std::queue<int> neiq;
    std::vector<int> inq(G.numVertices(), 0);
    std::vector<int> end(G.numVertices(), 0);

    int fir = S;
    perm[fir] = idx++;
    neiq.push(fir);
    inq[fir]=1;
    // popしたら無視へ，ququeに一回入れたらもう入れない，
    // for (int i = 0; i < G.numEdges(); i++) {
    while (!neiq.empty()) {
        int p = neiq.front();
        neiq.pop();
        // pop したら無視へ
        end[p] = 1;

        for (int j = 0; j < neighbor[p].size(); j++) {
            // 無視する
            if (end[neighbor[p][j].first] == 1) continue;

            // 　記憶になければ入れる
            if (inq[neighbor[p][j].first] == 0) {
                neiq.push(neighbor[p][j].first);
                perm[neighbor[p][j].first] = idx++; // perm?
                //　一回入れたら記憶して防ぐ
                inq[neighbor[p][j].first] = 1;
            }

            //(p>pj.f)-pj.s
            res_edges.push_back(std::make_pair(std::make_pair(perm[p], perm[neighbor[p][j].first]), neighbor[p][j].second)); // perm?
            //std::cout << "bfs edge: " << perm[p] << "," <<  perm[neighbor[p][j].first] << " -- " << neighbor[p][j].second << std::endl;
            res_inedge[perm[p]].push_back(std::make_pair(perm[neighbor[p][j].first], neighbor[p][j].second));
            //(pj.f>p)-pj.s
            //if (G.getDirection()) res_outedge[perm[neighbor[p][j].first]].push_back(std::make_pair(perm[p], neighbor[p][j].second));
            if (1) res_inedge[perm[neighbor[p][j].first]].push_back(std::make_pair(perm[p], neighbor[p][j].second));
            
            //std::cout << "(" << p << "," << neighbor[p][j].first << ") -- (" << perm[p] << "," << perm[neighbor[p][j].first] << ")" << std::endl;

        }
    }
    Graph res = Graph(G.numVertices(), G.numEdges(), G.numLength(), perm[G.getStart()], perm[G.getTerminal()],  res_edges);
    return res;

}

DiGraph pathBfs(DiGraph G, int S) { // in G, out res(辺を隣接順にしただけ) 
    std::vector<std::pair<std::pair<int, int>,int>> res_edges;
    std::vector<std::vector<std::pair<int, int>>> res_fg(G.numVertices()); //neighbor list
    std::vector<std::vector<std::pair<int, int>>> res_rg(G.numVertices());
    std::vector<int> perm(G.numVertices());
    int idx=0;
    
    std::vector<std::vector<std::pair<int,int>>> neighbor(G.numVertices());
    for (int i = 0; i < G.numVertices(); i++) {
        neighbor[i] = G.getForwardNeighbors(i);
    }
    // auto neighbor = G.getGraph(); // edge list

    // queueから出てくる頂点の隣接辺をリストに入れる
    std::queue<int> neiq;
    std::vector<int> inq(G.numVertices(), 0);
    std::vector<int> end(G.numVertices(), 0);

    int fir = S;
    perm[fir] = idx++;
    neiq.push(fir);
    inq[fir]=1;
    // popしたら無視へ，ququeに一回入れたらもう入れない，
    // for (int i = 0; i < G.numEdges(); i++) {
    while (!neiq.empty()) {
        int p = neiq.front();
        neiq.pop();
        // pop したら無視へ
        end[p] = 1;

        for (int j = 0; j < neighbor[p].size(); j++) {
            // 無視する
            // if (end[neighbor[p][j].first] == 1) continue;

            // 　記憶になければ入れる
            if (inq[neighbor[p][j].first] == 0) {
                neiq.push(neighbor[p][j].first);
                perm[neighbor[p][j].first] = idx++; // perm?
                //　一回入れたら記憶して防ぐ
                inq[neighbor[p][j].first] = 1;
            }

            //(p>pj.f)-pj.s
            res_edges.push_back(std::make_pair(std::make_pair(perm[p], perm[neighbor[p][j].first]), neighbor[p][j].second)); // perm?
            //std::cout << "bfs edge: " << perm[p] << "," <<  perm[neighbor[p][j].first] << " -- " << neighbor[p][j].second << std::endl;
            res_fg[perm[p]].push_back(std::make_pair(perm[neighbor[p][j].first], neighbor[p][j].second));
            //(pj.f>p)-pj.s
            res_rg[perm[neighbor[p][j].first]].push_back(std::make_pair(perm[p], neighbor[p][j].second));
            // if (1) res_inedge[perm[neighbor[p][j].first]].push_back(std::make_pair(perm[p], neighbor[p][j].second));
            
            //std::cout << "(" << p << "," << neighbor[p][j].first << ") -- (" << perm[p] << "," << perm[neighbor[p][j].first] << ")" << std::endl;

        }
    }
    DiGraph res = DiGraph(G.numVertices(), G.numEdges(), G.numLength(), perm[G.getStart()], perm[G.getTerminal()],  res_edges);
    return res;

}


Graph powLength(Graph G) { // pow計算時にしか使えない(半分半分を行うならこれも行わない)
    std::vector<std::pair<std::pair<int,int>, int>> res_edge_list;
    int idx = G.numVertices();
    for (int i = 0; i < G.numEdges(); i++) { // 一個一個の辺について
        auto e = G.getEdge(i);
        
        int u = e.first.first;
        int v = e.first.second;

        int l = e.second;
        int pow = 1, c = 1;
        std::vector<int> div;
        while(pow*2<=l) {pow*=2;}  // l以下の最大べき長 pow 

        while (pow != l) {
            int tmp = idx++;;
            res_edge_list.push_back(std::make_pair(std::make_pair(u,tmp), pow)); // 長さpowの辺
            std::cout << "pow: " << u << "," << tmp << "," << v << "(" << l << "-" << pow << std::endl;
            u = tmp;
            l = l-pow;
            pow = 1;
            while(pow*2<=l) pow*=2;    
        }
        if (pow==l) {
            res_edge_list.push_back(std::make_pair(std::make_pair(u,v), l));  
            std::cout << "rest: " << u << "," << v << "(" << l << std::endl;

        }
    }

    // std::vector<std::pair<std::pair<int, int>, int>> res_edge_list;
    std::vector<std::vector<std::pair<int, int>>> res_edge;
    res_edge.resize(idx);
    for(auto it = res_edge_list.begin(); it != res_edge_list.end(); ++it) {
        int u = (*it).first.first;
        int v = (*it).first.second;
        int c = (*it).second;
        res_edge[u].push_back(std::make_pair(v, c));
        res_edge[v].push_back(std::make_pair(u, c));
    }
    
    Graph res = Graph(idx, res_edge_list.size(), G.numLength(), G.getStart(), G.getTerminal(),  res_edge_list);
    std::cout << "-- pow fin --" << std::endl;
    return res;

}

void deleteLeaf(std::vector<std::set<std::pair<int, int>>> &fg, std::vector<std::set<std::pair<int, int>>> &rg, int u, int v, int c) {
    rg[u].erase(std::make_pair(v, c));
    fg[v].erase(std::make_pair(u, c));
}
DiGraph deleteLeaves(DiGraph g) {
        int n = g.numVertices(), m = g.numEdges();
        int s = g.getStart(), t = g.getTerminal();
        std::vector<int> validVertices(n, true);
        std::vector<int> numVertices(n);
        std::vector<std::set<std::pair<int, int>>> fg(n);
        std::vector<std::set<std::pair<int, int>>> rg(n);
        for(int i = 0; i < m; i++) {
            auto edge = g.getEdge(i);
            int u = edge.first.first;
            int v = edge.first.second;
            int c = edge.second;
            fg[u].insert(std::make_pair(v, c));
            rg[v].insert(std::make_pair(u, c));
        }

        std::stack<int> stk;
        for(int i = 0; i < n; i++) {
            if(i == s) continue;
            if(i == t) continue;
            if(fg[i].size() == 0) {
                stk.push(i);
            }
            if(rg[i].size() == 0) {
                stk.push(i);
            }
        }

        while(!stk.empty()) {
            int u = stk.top(); stk.pop();
            if(u == s) continue;
            if(u == t) continue;
            /* forward deletion */
            if(fg[u].size() == 0) {
                for(auto [v, c]: rg[u]) {
                    deleteLeaf(fg, rg, u, v, c);
                    if(fg[v].size() == 0) {
                        stk.push(v);
                    }
                }
            }
            /* reverse deletion */
            if(rg[u].size() == 0) {
                for(auto [v, c]: fg[u]) {
                    deleteLeaf(rg, fg, u, v, c);
                    if(rg[v].size() == 0) {
                        stk.push(v);
                    }
                }
            }
        }

        for(int i = 0; i < n; i++) {
            if(i == s) continue;
            if(i == t) continue;
            if(fg[i].size() == 0) validVertices[i] = false;
            if(rg[i].size() == 0) validVertices[i] = false;
        }
        int numValidVertices = 0;
        int numValidEdges = 0;
        int idx = 0;
        for(int i = 0; i < n; i++) {
            if(validVertices[i]) {
                numValidVertices++;
                numVertices[i] = idx++;
            }
        }

        std::vector<std::pair<std::pair<int, int>, int>> res_edge;
        for(int u = 0; u < n; u++) {
            for(auto [v, c]: fg[u]) {
                std::pair<int, int> e = std::make_pair(numVertices[u], numVertices[v]);
                // /**/std::cout << "del l: " << numVertices[u] << "," << numVertices[v] << std::endl;
                res_edge.push_back(std::make_pair(e, c));
                numValidEdges++;
            }
        }
        DiGraph res(n, m, g.numLength(), numVertices[s], numVertices[t], res_edge);
        return res;
}