#pragma once

#include <tdzdd/DdSpec.hpp>
#include <tdzdd/DdSpecOp.hpp>
#include <tdzdd/DdStructure.hpp>
#include <tdzdd/DdEval.hpp>

#include "../../digraph.cpp"
#include "convertEdgePermutation.cpp"

class WeightedSizeZDD: public tdzdd::DdSpec<WeightedSizeZDD, short, 2> {
    int n;
    int m;
    int l;
    DiGraph const G;
    std::vector<int> const perm;
    std::vector<int> edgePermutation;

public:
    WeightedSizeZDD(DiGraph G, std::vector<int> perm): G(G), perm(perm) {
        n = G.numVertices();
        m = G.numEdges();
        l = G.numLength();
        edgePermutation = convertEdgePermutation_weighted_directed(G, perm);
    }

    int getRoot(short& state) const {
        state = 0;
        return m;
    }

    int getChild(short& state, int level, int value) const {
        if(value == 1) {
            state += edgePermutation[m - level];
            if(state > l) return 0;
        }
        level--;
        if(level == 0) return -1;
        return level;
    }
};
