#pragma once

#include "graph.cpp"

Graph readGraph() {
    int n, m, l, s, t;
    s = -1;
    t = -1;
    std::vector<std::pair<std::pair<int, int>, int>> edge;
    char buf[1024];
    while(fgets(buf, sizeof(buf), stdin)) {
        if(buf[0] == 'p') {
            sscanf(buf, "p edge %d %d", &n, &m);
        }
        else if(buf[0] == 'e') {
            int u, v;
            sscanf(buf, "e %d %d", &u, &v);
            u--;
            v--;
            std::pair<int, int> e = std::make_pair(u, v);
            edge.push_back(std::make_pair(e, 1));
        }
        else if(buf[0] == 'l') {
            sscanf(buf, "l %d", &l);
        }
        else if(buf[0] == 't') {
            sscanf(buf, "t %d %d", &s, &t);
            s--;
            t--;
        }
        else if(buf[0] == 'c') {
            continue;
        }
    }
    std::sort(edge.begin(), edge.end());
    Graph G(n, m, l, s, t, edge);
    return G;
}

void writeGraph(Graph G, const char *file) {
    int n = G.numVertices();
    int m = G.numEdges();
    int l = G.numLength();
    int s = G.getStart();
    int t = G.getTerminal();
    s++;
    t++;
    FILE *fp = fopen(file, "wt");
    fprintf(fp, "p edge %d %d\n", n, m);
    for(int i = 0; i < m; i++) {
        int u = G.getEdge(i).first.first;
        int v = G.getEdge(i).first.second;
        int w = G.getEdge(i).second;
        u++;
        v++;
        fprintf(fp, "e %d %d\n", u, v);
    }
    fprintf(fp, "l %d\n", l);
    if(G.isOnepair()) fprintf(fp, "t %d %d\n", s, t);
    fclose(fp);
}
