// functions// scc de counting
//
#pragma once 
// start 20240910
// いつもの数え上げを成分ごとに使えるように関数化
#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <queue>
#include <string>
// ここから下はいらない
#include <time.h>
#include "ZBDD.h"
#include "CtoI.h" 
#include "SBDD_helper.h"
#include "ZddOperation.hpp"

#include <boost/multiprecision/cpp_int.hpp> // 要る
// #define boost/multiprecision/cpp_int.hpp int;

using namespace tdzdd;
using namespace sbddh;

std::map<std::tuple<int,int,int>, CtoI > e_memo;
std::map<std::tuple<int,int,int>, CtoI > memo;
int n;
long long ans = 0;
bool direction = false; // 有向無向で切り替えて欲しい

const int digit = 20;


void Initialize(std::vector<std::vector<std::pair<int,int>> > &g){
    memo.clear(); e_memo.clear();
    //
    int n = g.size();
    for(int i = 0; i < n; i++){
        for(int j = 0; j < (int)g[i].size(); j++){ // 辺のZDDはi,jのﾙｰﾌﾟでs-t，t-s両方作ってる
            CtoI res;
            int adj = g[i][j].first;
            res = getSingleSet(2, adj+digit+1, i+digit+1);
            res = res.NonZero();
            
            if(e_memo.count({i, adj, g[i][j].second})) {
                e_memo[{i, adj, g[i][j].second}] = e_memo[{i, adj, g[i][j].second}] + res;
                // /*多重片*/std::cout << "more edge" << std::endl;
            } else e_memo[{i, adj, g[i][j].second}] = res;
            // /**//*多重片*/if (e_memo[{i, adj, g[i][j].second}] != CtoI()) std::cout << "m: " << i << "," << adj << " - " << g[i][j].second << std::endl;
            
        }
    }

    // /* */ std::cout << "init" << std::endl;
}

CtoI ctoiCount(int s, int t, int l) { // 無向用確認
    if (memo.count({s,t,l})) {
        return memo[{s,t,l}];
    } else if (!direction && memo.count({t,s,l})) {
        return memo[{t,s,l}];
    } else return CtoI();
}
CtoI e_ctoiCount(int s, int t, int l) { // 無向用確認
    if (e_memo.count({s,t,l})) {
        return e_memo[{s,t,l}];
    } else if (!direction && e_memo.count({t,s,l})) { // !direction が重要
        return e_memo[{t,s,l}];
    } else return CtoI();
}



CtoI divide_conquer_ham(std::vector<std::vector<std::pair<int,int>>> nei, int s, int t, int l){
    if(memo.count({s, t, l})) {return memo[{s,t,l}];}
    else if(!direction && memo.count({t, s, l})) {return memo[{t,s,l}];} // 無向なら反対にも対応
    else if((e_memo.count({s,t,l}) == 0 /*&& e_memo.count({t,s,l}) == 0*/) && l <= 1){ // 長さ1越えの辺は，，，
        CtoI z;
        memo[{s,t,l}] = z;
        return z;
    }

    CtoI res = CtoI();
    auto neit = nei[t];
    for (auto u: neit) {
        if (u.first != s && u.first != t) {
            if (memo.count({s,u.first,l-u.second}) == 0) memo[{s,u.first,l-u.second}] = divide_conquer_ham(nei, s,u.first,l-u.second);
            if (memo[{s,u.first, l-u.second}] == CtoI()) continue;
            // /**/ if (l>2) std::cout << l << "=" << bi << "+" << 1 << std::endl;
            CtoI v_MidpointZdd = memo[{s,u.first,l-u.second}];
            //if (direction) CtoI v_MidpointZdd = multiple_djj(divide_conquer(G, t,v,floor((double)l / (double)2)), divide_conquer(G, v,s,floor((double)l / (double)2)), v);
            res = res + v_MidpointZdd.Factor0(t+digit+1).AffixVar(t+digit+1);
            // /**/std::cout << s << "-" << u.first << "~" << t << std::endl;
        }
    }
    
    res = res+e_ctoiCount(s,t,l);
    memo[{s,t,l}] = res;
    
    return res;
}

// 成分分解ver，始点終点が複数ある
std::vector<std::vector<std::vector<long long>>> sccCounting(int n, std::vector<std::pair<std::pair<int,int>, int>> edge, std::vector<int> starts, std::vector<int> terminals, int limit) {
    
    // 返値
    std::vector<std::vector<std::vector<long long>>> res(starts.size(), std::vector<std::vector<long long>> (terminals.size(), std::vector<long long> (limit + 1,0))); // 初期値は．．．       
    // 頂点が1つのみの場合
    if (starts.size() == 1 && terminals.size() == 1 && starts[0] == terminals[0]) { // 成分内の頂点が1つのみの場合
        res[starts[0]][terminals[0]][0] = 1;
        // /**/ std::cout << "only one fin" << std::endl;
        return res;
    }

    // 隣接リストを作る
    std::vector<std::vector<std::pair<int, int>>> forward(n);//, std::vector<std::pair<int, int>>);
    std::vector<std::vector<std::pair<int, int>>> receive(n);//, std::vector<std::pair<int, int>>);
    for (int i = 0; i < edge.size(); i++) {
        // /**/ std::cout << edge[i].first.first << "," << edge[i].first.second << " - " << edge[i].second << std::endl;
        forward[edge[i].first.first].push_back(std::make_pair(edge[i].first.second, edge[i].second));
        receive[edge[i].first.second].push_back(std::make_pair(edge[i].first.first, edge[i].second));
    }

    // CtoIを準備
    memo.clear(); e_memo.clear();
    BDD_Init(1024, 1024 * 1024 * 1024);
    BDDV_Init();
    for(int i = 0; i <= n+digit; i++) BDD_NewVar(); // 1~n
    
    Initialize(forward);
    // /**/ std::cout << "init:" << limit << std::endl;

    // s,t,lごとに構築
    // 長さ0だけ別
    for (int i = 0; i < starts.size(); i++) {
        int s = starts[i];
        for (int j = 0; j < terminals.size(); j++) {
            int t = terminals[j];
            // /**/ std::cout << "s-t: " << s << "," << t << std::endl; 
            if (s == t) res[i][j][0] = 1;
        }
    }
    // /**/ std::cout << "len 0" << std::endl;

    for (int len = 1; len < limit+1; len++) {
        for (int i = 0; i < starts.size(); i++) {
            int s = starts[i];
            for (int j = 0; j < terminals.size(); j++) {
                int t = terminals[j];
                if (s == t) {
                    res[i][j][len] == 0;
                    continue;
                }
                divide_conquer_ham(receive, s, t, len);
                // /**/ std::cout << "ham" << std::endl;

                // 数値変換
                char buf[1024];
                if (memo[{s,t,len}].TotalVal().IsConst()) {
                    memo[{s,t,len}].TotalVal().StrNum10(buf);
                    std::string str = buf;
                    res[i][j][len]= std::stoll(str);
                    // /**/ std::cout << "(" << s + 1  << "," << t + 1<< ")-" << len << " → ";
                    // /**/ std::cout << std::stoll(str) << std::endl;

                    
                }
            }
        }
        // /**/ std::cout << "len " << len << std::endl;
    }
    // /**/ std::cout << "fin" << std::endl;
    return res;
}

// 成分分解なしver，始点終点は1:1
std::string pathCounting(int n, std::vector<std::pair<std::pair<int,int>, int>> edge, int start, int terminal, int limit) {
    
    
    // 隣接リストを作る
    std::vector<std::vector<std::pair<int, int>>> forward(n);//, std::vector<std::pair<int, int>>);
    std::vector<std::vector<std::pair<int, int>>> receive(n);//, std::vector<std::pair<int, int>>);
    for (int i = 0; i < edge.size(); i++) {
        // /**/ std::cout << edge[i].first.first << "," << edge[i].first.second << " - " << edge[i].second << std::endl;
        forward[edge[i].first.first].push_back(std::make_pair(edge[i].first.second, edge[i].second));
        receive[edge[i].first.second].push_back(std::make_pair(edge[i].first.first, edge[i].second));
        if (!direction) {
            receive[edge[i].first.first].push_back(std::make_pair(edge[i].first.second, edge[i].second));
            forward[edge[i].first.second].push_back(std::make_pair(edge[i].first.first, edge[i].second));
            
        } 
    }

    // CtoIを準備
    memo.clear(); e_memo.clear();
    BDD_Init(1024, 1024 * 1024 * 1024);
    BDDV_Init();
    for(int i = 0; i <= n+digit; i++) BDD_NewVar(); // 1~n
    
    Initialize(forward);
    // /**/ std::cout << "init:" << limit << std::endl;

    boost::multiprecision::cpp_int sum = 0;
        
    for (int len = 1; len < limit+1; len++) {
        for (int i = 0; i < 1; i++) {
            // int s = starts[i];
            for (int j = 0; j < 1; j++) {
                // int t = terminals[j];
                if (start == terminal) {
                    // res[i][j][len] == 0;
                    continue;
                }
                divide_conquer_ham(receive, start, terminal, len);
                // /**/ std::cout << "ham" << std::endl;

                // 数値変換
                char buf[1024];
                if (memo[{start,terminal,len}].TotalVal().IsConst()) {
                    memo[{start,terminal,len}].TotalVal().StrNum10(buf);
                    std::string str = buf;
                    sum += std::stoll(str);
                    // /**/ std::cout << "(" << s + 1  << "," << t + 1<< ")-" << len << " → ";
                    // /**/ std::cout << std::stoll(str) << std::endl;

                    
                }
            }
        }
        // /**/ std::cout << "len " << len << std::endl;
    }
    // /**/ std::cout << "fin" << std::endl;
    return sum.str();
}
